Devuan bug report logs - #314
gpsd: ..2'nd roll over bug: gpsd "clock is 56 years wrong", like "1963-07-18T08:57:40.584Z"

version graph

Package: gpsd; Maintainer for gpsd is Boian Bonev <bbonev@ipacct.com>;

Reported by: Arnt Karlsen <arnt@iaksess.no>

Date: Sun, 7 Apr 2019 21:33:01 UTC

Severity: normal

Fixed in version 3.20-12+devuan1

Done: dak@devuan.org

Full log


🔗 View this message in rfc822 format

MIME-Version: 1.0
X-Mailer: MIME-tools 5.509 (Entity 5.509)
X-Loop: owner@bugs.devuan.org
From: "Devuan bug Tracking System" <owner@bugs.devuan.org>
To: dak@devuan.org
Subject: bug#314: marked as done (gpsd: ..2'nd roll over bug: gpsd "clock
 is 56 years wrong", like "1963-07-18T08:57:40.584Z")
Message-ID: <handler.314.D314.15969972081707.ackdone@bugs.devuan.org>
References: <1596992218.633550.12958.nullmailer@dak.ganeti1.devuan.org>
 <20190407221907.7d777d42@sda3>
X-Devuan-PR-Message: closed 314
X-Devuan-PR-Package: gpsd
Reply-To: 314@bugs.devuan.org
Date: Sun, 09 Aug 2020 18:33:01 +0000
Content-Type: multipart/mixed; boundary="----------=_1596997981-1886-0"
[Message part 1 (text/plain, inline)]
Your message dated Sun, 09 Aug 2020 16:56:58 +0000
with message-id <1596992218.633550.12958.nullmailer@dak.ganeti1.devuan.org>
and subject line #314: fixed in src:gpsd version 3.20-12+devuan1
has caused the Devuan bug report #314,
regarding gpsd: ..2'nd roll over bug: gpsd "clock is 56 years wrong", like "1963-07-18T08:57:40.584Z"
to be marked as done.

This means that you claim that the problem has been dealt with.
If this is not the case it is now your responsibility to reopen the
bug report if necessary, and/or fix the problem forthwith.

(NB: If you are a system administrator and have no idea what this
message is talking about, this may indicate a serious mail system
misconfiguration somewhere. Please contact owner@bugs.devuan.org
immediately.)


-- 
314: https://bugs.devuan.org/cgi/bugreport.cgi?bug=314
Devuan Bug Tracking System
Contact owner@bugs.devuan.org with problems
[Message part 2 (message/rfc822, inline)]
From: Arnt Karlsen <arnt@iaksess.no>
To: Devuan Bug Tracking System <submit@bugs.devuan.org>, Debian Bug Tracking System <submit@bugs.debian.org>
Cc: gpsd-dev@lists.nongnu.org
Subject: gpsd: ..2'nd roll over bug: gpsd "clock is 56 years wrong", like "1963-07-18T08:57:40.584Z"
Date: Sun, 7 Apr 2019 22:57:58 +0200
Package: gpsd
Version: 3.16-4
Severity: important

..upstream bug.  




Hi,


..reportbug reports our (Devuan) BTS is down, bug report on gpsd: 
Content-Type
: text/plain; charset="us-ascii"
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
From: Arnt <arnt@iaksess.no>
To: Devuan Bug Tracking System <submit@bugs.devuan.org>
Subject: gpsd: ..2'nd roll over bug: gpsd clock is 56 years wrong,
"1963-07-18T08:57:40.584Z" Message-ID:
<155465156363.24771.3526445890355259661.reportbug@sda3> X-Mailer:
reportbug 7.1.6+devuan2.1 Date: Sun, 07 Apr 2019 17:39:23 +0200
X-Debbugs-Cc: arnt@iaksess.no

Package: gpsd
Version: 3.16-4
Severity: important

..upstream bug.  


Dear Maintainer,

*** Reporter, please consider answering these questions, where
appropriate ***

   * What led up to the situation?

..according to http://catb.org/gpsd/NMEA.html#_dates_and_times : 
GPS date and time are subject to a rollover problem in the 10-bit 
week number counter, which will re-zero every 1024 weeks (roughly 
every 19.6 years). The last rollover (and the first since GPS went 
live in 1980) was in Aug-1999; the next will fall in Apr-2019. 


..checks out rather well:
arnt@sda3:~$ date --date='1024 weeks ago'
Sun Aug 22 18:23:04 CEST 1999
arnt@sda3:~$ date --date='2048 weeks ago'
Sun Jan  6 17:23:36 CET 1980
arnt@sda3:~$ date --date='TZ=UTC 2048 weeks ago'
date: invalid date ‘TZ=UTC 2048 weeks ago’
arnt@sda3:~$ date --date='TZ="UTC" 2048 weeks ago'
Sun Jan  6 19:25:50 CET 1980
arnt@sda3:~$
http://www.leapsecond.com/java/gpsclock.htm
http://www.leapsecond.com/java/cal.htm


..fix suggestions: hard code third 10bit era and/or move to 
the new 13bit "CNAV" data format pointed to above. 

..this patch hard codes third 10bit era as suggested in 
gpsd-3.1x's timebase.c:
arnt@nb6:~$ diff -u timebase.h-3.16 timebase.h-new
--- timebase.h-3.16     2016-01-08 20:30:27.000000000 +0100
+++ timebase.h-new      2019-04-07 20:11:52.903644739 +0200
@@ -1,9 +1,9 @@
 /*
  * Constants used for GPS time detection and rollover correction.
  *
- * Correct for week beginning 2016-01-07T00:00:00
+ * Correct for week beginning 2019-04-07T02:00:00 UTC
  */
 #define BUILD_CENTURY  2000
-#define BUILD_WEEK     854            # Assumes 10-bit week counter 
-#define BUILD_LEAPSECONDS      17
-#define BUILD_ROLLOVERS        1      # Assumes 10-bit week counter
+#define BUILD_WEEK     1              # Assumes 10-bit week counter 
+#define BUILD_LEAPSECONDS      19
+#define BUILD_ROLLOVERS        2      # Assumes 10-bit week counter


..and ditto for gpsd-3.17:
arnt@nb6:~$ diff -u timebase.h-3.17 timebase.h-new
--- timebase.h-3.17     2017-09-07 13:53:40.000000000 +0200
+++ timebase.h-new      2019-04-07 20:11:52.903644739 +0200
@@ -1,9 +1,9 @@
 /*
  * Constants used for GPS time detection and rollover correction.
  *
- * Correct for week beginning 2017-09-07T00:00:00
+ * Correct for week beginning 2019-04-07T02:00:00 UTC
  */
 #define BUILD_CENTURY  2000
-#define BUILD_WEEK     941           # Assumes 10-bit week counter 
+#define BUILD_WEEK     1             # Assumes 10-bit week counter 
#define BUILD_LEAPSECONDS      19
-#define BUILD_ROLLOVERS        1         # Assumes 10-bit week counter
+#define BUILD_ROLLOVERS        2         # Assumes 10-bit week counter



..this patch hard codes third 10bit era as suggested in 
gpsd-3.11's timebase.c: 
arnt@sda3:~$ diff -u timebase.h*
--- timebase.h-3.11  2019-04-07 19:19:42.442197516 +0200
+++ timebase.h-ny      2019-04-07 19:18:28.572535352 +0200
@@ -1,8 +1,8 @@
 /*
  * Constants used for GPS time detection and rollover correction.
  *
- * Correct for week beginning 2014-08-21T00:00:00
+ * Correct for week beginning 2019-04-07T00:00:00
  */
-#define CENTURY_BASE   201400
-#define LEAPSECOND_NOW 16
-#define GPS_WEEK_NOW   1806
+#define CENTURY_BASE   201900
+#define LEAPSECOND_NOW 19
+#define GPS_WEEK_NOW   2049


..current timebase.h in gpsd-3.11 source:
arnt@sda3:~$ cat timebase.h
/*
 * Constants used for GPS time detection and rollover correction.
 *
 * Correct for week beginning 2014-08-21T00:00:00
 */
#define CENTURY_BASE    201400
#define LEAPSECOND_NOW  16
#define GPS_WEEK_NOW    1806
arnt@sda3:~$




   * What exactly did you do (or not do) that was effective (or
     ineffective)?
   * What was the outcome of this action?
   * What outcome did you expect instead?

*** End of the template - remove these template lines ***


-- System Information:
Distributor ID: Devuan
Description:    Devuan GNU/Linux 2.0 (ascii)
Release:        2.0
Codename:       ascii

Architecture: armv6l

Kernel: Linux 4.19.32+
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=locale: Cannot
set LC_ALL to default locale: No such file or directory UTF-8)
Shell: /bin/sh linked to /bin/dash
Init: sysvinit (via /sbin/init)

Versions of packages gpsd depends on:
ii  adduser              3.115
ii  init-system-helpers  1.48+devuan2.0
ii  libbluetooth3        5.43-2+deb9u1
ii  libc6                2.24-11+deb9u4
ii  libdbus-1-3          1.10.22-1+devuan2
ii  libgps22             3.16-4
ii  libusb-1.0-0         2:1.0.21-1
ii  lsb-base             4.1+devuan2
ii  netbase              5.4

Versions of packages gpsd recommends:
ii  python  2.7.13-2
pn  udev    <none>

Versions of packages gpsd suggests:
ii  dbus          1.10.22-1+devuan2
ii  gpsd-clients  3.16-4

-- debconf information:


-- 
..med vennlig hilsen = with Kind Regards from Arnt Karlsen
...with a number of polar bear hunters in his ancestry...
  Scenarios always come in sets of three: 
  best case, worst case, and just in case.
[Message part 3 (message/rfc822, inline)]
From: dak@devuan.org
To: 314-done@bugs.devuan.org
Subject: #314: fixed in src:gpsd version 3.20-12+devuan1
Date: Sun, 09 Aug 2020 16:56:58 +0000
Version: 3.20-12+devuan1

Source package gpsd (3.20-12+devuan1) added to Devuan suite unstable.

This closes bug report 314.

Thanks

DAK managing the Devuan archive

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Tue, 14 Jul 2020 20:41:45 +0000
Source: gpsd
Binary: gpsd gpsd-dbg gpsd-tools gpsd-clients python3-gps libgps26 libgps-dev libqgpsmm26 libqgpsmm-dev
Architecture: source
Version: 3.20-12+devuan1
Distribution: unstable
Urgency: medium
Maintainer: Boian Bonev <bbonev@ipacct.com>
Changed-By: Boian Bonev <bbonev@ipacct.com>
Description:
 gpsd       - Global Positioning System - daemon
 gpsd-clients - Global Positioning System - clients
 gpsd-dbg   - Global Positioning System - debugging tools
 gpsd-tools - Global Positioning System - tools
 libgps-dev - Global Positioning System - development files
 libgps26   - Global Positioning System - library
 libqgpsmm-dev - Global Positioning System - Qt wrapper for libgps (development)
 libqgpsmm26 - Global Positioning System - Qt wrapper for libgps
 python3-gps - Global Positioning System - Python 3 libraries
Closes: 314 490
Changes:
 gpsd (3.20-12+devuan1) unstable; urgency=medium
 .
   * Fork Debian package for Devuan (Closes: #490, #314)
   * Remove systemd related stuff and restore sysvinit startup
   * Install gpsd-dbg binaries under /usr/libexec/gpsd
   * Enable hardened build
   * Update standards to 4.5.0
   * Bump debhelper to 13
   * Fix typos in code and documentation
   * Fix possible format buffer overrun
   * Do not install skyview.php as executable
   * Do not install gps.py as executable
   * Fix scons clean command
Checksums-Sha1:
 dfda298689883c108c27f6c72ac6b1088d48b78c 2393 gpsd_3.20-12+devuan1.dsc
 0bb2643378927dbdf33808e0ec474eab72ca6db7 75904 gpsd_3.20-12+devuan1.debian.tar.xz
 52953034858f971f471eedda4a8f65e9489928f5 4493 gpsd_3.20-12+devuan1_source.buildinfo
Checksums-Sha256:
 32701391a354a6a3d813ab8b031a63dd4c858a573b92de7c213552043aa79bd3 2393 gpsd_3.20-12+devuan1.dsc
 1475f19bbfb79c185bd711bcea2ac6219006688cee45cd21cb73383906567945 75904 gpsd_3.20-12+devuan1.debian.tar.xz
 e21c70db28c0bde03c075d985996cc193b1737fc0e2f6038fc19a00d65cce82e 4493 gpsd_3.20-12+devuan1_source.buildinfo
Files:
 026a27b07dd2cabe1168952a9e5f4bee 2393 misc optional gpsd_3.20-12+devuan1.dsc
 77f47ade06721ead08e42b02f2b8165c 75904 misc optional gpsd_3.20-12+devuan1.debian.tar.xz
 d864395dd803bc583c40628bf70c9f02 4493 misc optional gpsd_3.20-12+devuan1_source.buildinfo

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEcuPLdzMV36LkZHQ9lFMhJFQZIvsFAl8wKGoACgkQlFMhJFQZ
IvtFDQf+MXKMp28oBRtqU/3dHnfRlRXqg5geFrXqoEUXkVPhJvoNpaYSjzvQOATd
w80ItEgdtQzsfDNcMIxh1Ejl/hcYOlNkbmb6AFZb5xf4vRxKYljW+YsyCTIpj6C+
Bn/N44i3PqkRneZ4rvHjuCo1ZwYM3L9o05SPRxQHeAf/+OMqZWAkVr2HKUTCWpPR
eW9V2tdJJY5F+avuQfJRTH1OvmE2r3x86pQsjfCmAhzuBbn7Qff8DB0nn3hLyaqE
5xhGCeyEXmZoh7O1tmSvK2/TEBxYvSPmy+LxG7ccherji4vEEbZgs1dpj7QL9Xxb
Nuqytlf0JXAu3KUsCBlJom73WW5ebQ==
=YwmN
-----END PGP SIGNATURE-----

Send a report that this bug log contains spam.


Devuan BTS -- Powered by Debian bug tracking system
Copyright (C) 1999 Darren O. Benham,
1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson,
2005-2017 Don Armstrong, and many other contributors.

Devuan Bugs Owner <owner@bugs.devuan.org>.
Last modified: Mon Oct 25 06:15:49 2021;